#ifndef CAMERA_H
#define CAMERA_H

#include "vec4.h"
#include "defines.h"

#include <GL/glut.h>

class Camera{
public:
	vec4 eye;									// camera position
	vec4 lookAt;								// camera lookAt vector(should be relative to eye)
	vec4 viewUp;								// camera viewUp vector
	unsigned int moveState;						// camera flags for movement
	bool groundMove;							// flag for ground movement
	GLfloat xzAngle;							// value to determine x,z lookAt values
	float incX;									// rotation speedX
	float incY;									// rotation speedY
	float speed;								// movement speed

	Camera();
	~Camera();
	void rotate(float dX, float dY);
	void addState(unsigned int state);
	void removeState(unsigned int state);
	void update();
};
#endif