varying float mapCoord;
varying vec2 texCoord;

void main( void )
{
   vec3 ecPos = vec3( gl_ModelViewMatrix * gl_Vertex );
   vec3 lightVec = normalize(gl_LightSource[0].position.xyz - ecPos);
   vec3 normal = normalize(gl_NormalMatrix * gl_Normal);
   float NdotL = clamp(dot(normal, lightVec), 0.0, 1.0);
   float NdotH = clamp(dot(normal, gl_LightSource[0].halfVector.xyz), 0.0, 1.0);
   
   vec4 ambient = gl_FrontMaterial.ambient * gl_LightSource[0].ambient * .25;
   vec4 diffuse = gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse * NdotL * .50;
   vec4 specular = gl_FrontMaterial.specular * gl_LightSource[0].specular * 
                   pow(NdotH, gl_FrontMaterial.shininess);
   
   float ambientT = ambient.x+ambient.y+ambient.z/3.0;
   float diffuseT = diffuse.x+diffuse.y+diffuse.z/3.0;
   float specularT = specular.x+specular.y+specular.z/3.0;
   
   mapCoord = clamp(ambientT + diffuseT + specularT, 0.01, 0.99);
   texCoord = gl_MultiTexCoord0.xy;
   gl_Position = ftransform();
}