uniform sampler2D Hatch0;
uniform sampler2D Hatch1;
uniform sampler2D Hatch2;
uniform sampler2D Hatch3;
uniform sampler2D Hatch4;
uniform sampler2D Hatch5;

uniform sampler2D ModelTex;

varying vec2 vTexCoord;

varying float vHatchWeight0;
varying float vHatchWeight1;
varying float vHatchWeight2;
varying float vHatchWeight3;
varying float vHatchWeight4;
varying float vHatchWeight5;
varying float vHatchWeight6;

uniform vec2 fViewportDimensions;

void main()
{
	vec2 screenTex = gl_FragCoord.xy/fViewportDimensions;
	float scale = 4.0;
	vec4 hatchColor = vec4(1.0) * vHatchWeight6 +
		texture2D(Hatch0,screenTex * scale) * vHatchWeight0 +
		texture2D(Hatch1,screenTex * scale) * vHatchWeight1 +
		texture2D(Hatch2,screenTex * scale) * vHatchWeight2 +
		texture2D(Hatch3,screenTex * scale) * vHatchWeight3 +
		texture2D(Hatch4,screenTex * scale) * vHatchWeight4 +
		texture2D(Hatch5,screenTex * scale) * vHatchWeight5;	    
	
	vec4 texcolor = texture2D(ModelTex,vTexCoord);
	
	vec4 mixcolor = mix(vec4(1,1,1,1), hatchColor, 0.9) * texcolor*0.95;
	gl_FragColor = mixcolor;
}