varying vec2 vTexCoord;

varying float vHatchWeight0;
varying float vHatchWeight1;
varying float vHatchWeight2;
varying float vHatchWeight3;
varying float vHatchWeight4;
varying float vHatchWeight5;
varying float vHatchWeight6;

void main() 
{
   gl_Position = gl_ModelViewProjectionMatrix * gl_Vertex;
   vTexCoord = vec2(gl_MultiTexCoord0);

   vec3 ecPos = vec3(gl_ModelViewMatrix * gl_Vertex);
   vec3 lightDir = normalize( gl_LightSource[0].position.xyz - ecPos );

   vec3 posW    = gl_NormalMatrix * gl_Vertex.xyz;
   vec3 normalW = normalize(gl_NormalMatrix * gl_Normal);

   float  diffuse = min(1.0,max(0.0,dot(lightDir.xyz,normalW)));

   float  hatchFactor = diffuse * 12.0;
   vHatchWeight0 = 0.0;
   vHatchWeight1 = 0.0;
   vHatchWeight2 = 0.0;
   vHatchWeight3 = 0.0;
   vHatchWeight4 = 0.0;
   vHatchWeight5 = 0.0;
   vHatchWeight6 = 0.0;

   if (hatchFactor>6.0)
   {
 		vHatchWeight6 = 1.0;

   } 
   else if (hatchFactor>5.0)
   {
 	//	vHatchWeight0 = 1.0; 
 	vHatchWeight6 = 1.0 - (6.0 - hatchFactor);
 	vHatchWeight0 = 1.0 - vHatchWeight6;

   } 
   else if (hatchFactor>4.0)
   {
      vHatchWeight0 = 1.0 - (5.0 - hatchFactor);
      vHatchWeight1 = 1.0 - vHatchWeight0;
   } // End else if

   else if (hatchFactor>3.0)
   {
      vHatchWeight1 = 1.0 - (4.0 - hatchFactor);
      vHatchWeight2 = 1.0 - vHatchWeight1;
   } // End else if

   else if (hatchFactor>2.0)
   {
      vHatchWeight2 = 1.0 - (3.0 - hatchFactor);
      vHatchWeight3 = 1.0 - vHatchWeight2;
   } // End else if

   else if (hatchFactor>1.0)
   {
      vHatchWeight3 = 1.0 - (2.0 - hatchFactor);
      vHatchWeight4 = 1.0 - vHatchWeight3;
   } // End else if

   else// if (hatchFactor>0.0)
   {
      vHatchWeight4 = 1.0 - (1.0 - hatchFactor);
      vHatchWeight5 = 1.0 - vHatchWeight4;
   } // End else if

}